# SignListWindow Struct Reference

Inheritance diagram for SignListWindow:

## Public Member Functions

| SignListWindow (const WindowDesc *desc, WindowNumber window_number)
virtual void | OnPaint ()
| The window must be repainted.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnResize ()
| Called after the window got resized.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | OnInvalidateData (int data)
| Some data on this window has become invalid.

## Data Fields

int | text_offset

## Detailed Description

Definition at line 89 of file signs_gui.cpp.

## Member Function Documentation

virtual void SignListWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 109 of file signs_gui.cpp.

References _dynlang, DrawString(), FONT_HEIGHT_NORMAL, Scrollbar::GetCount(), Scrollbar::GetPosition(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem< Tpool >::index, Scrollbar::IsVisible(), OWNER_NONE, Window::resize, SetDParam(), SLW_LIST, ResizeInfo::step_height, TD_RTL, DynamicLanguages::text_dir, Window::vscroll, WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, WD_FRAMERECT_TOP, and WD_FRAMETEXT_LEFT.

virtual void SignListWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 146 of file signs_gui.cpp.

References Scrollbar::GetCapacity(), Scrollbar::GetCount(), Scrollbar::GetPosition(), Window::resize, SLW_LIST, ResizeInfo::step_height, Window::vscroll, and WD_FRAMERECT_TOP.

virtual void SignListWindow::OnInvalidateData | ( | int | data | ) | `[inline, virtual]`

Some data on this window has become invalid.

Parameters:

  | data | information about the changed data.

Reimplemented from Window.

Definition at line 185 of file signs_gui.cpp.

References GUIList< T, F >::ForceRebuild(), GUIList< T, F >::ForceResort(), SmallVector< T, S >::Length(), Scrollbar::SetCount(), Window::SetWidgetDirty(), SLW_CAPTION, and Window::vscroll.

virtual void SignListWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 104 of file signs_gui.cpp.

References Window::DrawWidgets().

virtual void SignListWindow::OnResize | ( |  | ) | `[inline, virtual]`

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 160 of file signs_gui.cpp.

References Scrollbar::SetCapacityFromWidget(), SLW_LIST, Window::vscroll, WD_FRAMERECT_BOTTOM, and WD_FRAMERECT_TOP.

virtual void SignListWindow::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 141 of file signs_gui.cpp.

References Scrollbar::GetCount(), SetDParam(), SLW_CAPTION, and Window::vscroll.

virtual void SignListWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 165 of file signs_gui.cpp.

References FONT_HEIGHT_NORMAL, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_sign_pool >::GetPoolSize(), GetSpriteSize(), GetStringBoundingBox(), MAX_LENGTH_SIGN_NAME_PIXELS, maxdim(), SetDParam(), SLW_CAPTION, SLW_LIST, WD_FRAMERECT_BOTTOM, WD_FRAMERECT_TOP, WD_FRAMETEXT_LEFT, and WD_FRAMETEXT_RIGHT.

The documentation for this struct was generated from the following file:

- src/signs_gui.cpp